import java.awt.Color;

/**
 * Eine Spalte im "Vier gewinnt".
 * 
 * @author Selina M., Bianca R., Lara R., Sophie T.
 * @author Bernd Gramlich
 * @version 2015-05-11
 */
public class Spalte
{
    /*
     * Ein Feld fr die sieben Scheiben der Spalte.
     */
    private Ellipse[] scheibe;
    
    /*
     * Die Anzahl der in dieser Spalte bereits gespielten Scheiben.
     */
    private int anzahl;
    
    /**
     * Erstelle eine Spalte, die aus sieben bereinanderliegenden Scheiben besteht.
     */
    public Spalte (int x)
    {
       scheibe = new Ellipse [7];
       anzahl = 0;
       
       for (int i = 0; i <= 6; i++)
       {
           scheibe[i] = new Ellipse ();
           scheibe[i].setzePosition (x, 340 - 55*i);
           scheibe[i].setzeHoehe (50);
           scheibe[i].setzeBreite (50);   
       }
    }
    
    /**
     * Wirf einen Chip in die Spalte.
     */
    public void wirfEin (Color scheibenfarbe)
    {
        scheibe[anzahl].setzeFarbe (scheibenfarbe);
        scheibe[anzahl].werdeSichtbar ();
        anzahl++;      
    }
    
    /**
     * Zeige an ob die Spalte voll ist.
     */
    public boolean spalteVoll ()
    {
        if (anzahl == 7)
        {
            return true;
        }
        
        else
        {
            return false;
        }
    } 
    
    /**
     * Gib die Farbe des Chips mit der entsprechenden Chipnummer aus.
     */
    public Color gibFarbe (int chipNr)
    {  
        if (chipNr < anzahl)
        {
            return scheibe[chipNr].gibFarbe ();
        }
        else
        {
            return null;
        }
    }
    
    /**
     * Leere den Schacht.
     */
    public void leere ()
    {
        anzahl = 0;
        
        for (int i = 0; i <= 6; i++)
        {
            scheibe[i].werdeUnsichtbar ();   
        }
    }        
}