import java.awt.Color;

/**
 * Eine Clientversion von "Vier gewinnt".
 * 
 * @author Selina M., Bianca R., Lara R., Sophie T.
 * @author Bernd Gramlich
 * @version 2015-05-11
 */
public class Spiel
{
    private Spalte[] schacht;
    private Color naechsteFarbe;
    private Beschriftung[] schachtNummer;
    private Beschriftung ueberschrift;
    
    private Color rot  = new Color (255, 0, 0);
    private Color gelb = new Color (255, 255, 0);
    private Color grau = new Color (127, 127, 127);

    /**
     * Erstelle ein Spiel aus 7 Schchten.
     */
    public Spiel ()
    {
        Leinwand.erzeugeLeinwand ("Vier Gewinnt by Lara, Bianca, Sophie, Selina", 600, 450, Color.white);
        
        naechsteFarbe = rot;

        schacht = new Spalte [7];
        schachtNummer = new Beschriftung [7];

        for (int i = 0; i <= 6; i++)
        {
            schacht [i] = new Spalte(i*55);

            schachtNummer[i] = new Beschriftung ();
            schachtNummer[i].setzeInhalt ("" + i);
            schachtNummer[i].setzeFarbe (grau);
            schachtNummer[i].setzeSchriftgroesse (40);
            schachtNummer[i].setzePosition (23 + i*55, 420);
            schachtNummer[i].werdeSichtbar ();
        }

        ueberschrift = new Beschriftung ();
        ueberschrift.setzeInhalt ("Vier gewinnt");
        ueberschrift.setzeFarbe (grau);
        ueberschrift.setzeSchriftgroesse (80);
        ueberschrift.setzePosition (300, 225);
        ueberschrift.werdeSichtbar ();	
        
        Leinwand.gibLeinwand ().erneuere ();
    }

    /**
     * Prfe ob die Spalte voll ist und wechsle die Farbe der Scheibe nach jeden Wurf.
     */
    public void wirfNaechsteFarbeEin (int Spaltennummer)
    {
        if (!schacht [Spaltennummer].spalteVoll ())
        {
            if (naechsteFarbe == rot)
            {
                naechsteFarbe = gelb;
            }
            else 
            {
                naechsteFarbe = rot;
            }
            schacht[Spaltennummer].wirfEin (naechsteFarbe) ;
        }
        
        Leinwand.gibLeinwand ().erneuere ();
    }
    
    /**
     * Wirf einen Chip in eine beliebige Spalte ein.
     */
    private void wirfEin (int Spaltennummer)
    {
        schacht[Spaltennummer].wirfEin (naechsteFarbe) ;  
    }
    
    /**
     * Fange an.
     */
    public void fangeAn ()
    {
        /*
         * Lsche die berschrift und zeige die Schachtnummern an.
         */
        ueberschrift.werdeUnsichtbar ();

        for (int i = 0; i <= 6; i++)
        {
            schachtNummer[i].werdeSichtbar ();
        }
        
        Leinwand.gibLeinwand ().erneuere ();
    }
    
    /**
     * Hre auf.
     */
    public void hoereAuf ()
    {
        /*
         * Leere alle Schchte, lsche die Schachtnummern und zeige die normale berschrift an.
         */
        for (int i = 0; i <= 6; i++)
        {
            schacht[i].leere ();
            schachtNummer[i].werdeUnsichtbar ();
        }
        ueberschrift.setzeInhalt ("Vier gewinnt");
        ueberschrift.werdeSichtbar ();

        /*
         * Lass gelb im nchsten Spiel wieder beginnen.
         */
        naechsteFarbe = rot;
    }
}